#!/usr/bin/python
#Filename: rripanels.py
''' Draw the panels for the Recorder Reproducer Interface device.'''

#
# Import the panel work drawing tools and component library ...
#

from panelwork import *

doboxes = False

def doBoxes( yes ):
    ''' Draw colour areas or not.'''
    global doboxes
    doboxes = yes

#
# Strips ...
#


def channelMicA( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-55, -110, 110, 1130, 0.85 )
        grayBoxLabel( f, x+55, -110, 70, 625, 0.85 )
    else:
        sw1LabelLedsR( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsR( f, x, 150, 'Line', 'Mic' )
        sw1LabelLedsR( f, x, 300, '-20dB', 'Pad' )
        sw1LabelLedsR( f, x, 450, '+48V', 'Off' )
        potLabel( f, x, 660, 'Gain' )
        drawTextCB( f, x, 1050, 'MIC A', 'f2' )

def channelMicB( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-55, -110, 110, 1130, 0.85 )
        grayBoxLabel( f, x+55, -110, 70, 625, 0.85 )
    else:
        sw1LabelLedsR( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsR( f, x, 150, 'Line', 'Mic' )
        sw1LabelLedsR( f, x, 300, '-20dB', 'Pad' )
        sw1LabelLedsR( f, x, 450, '+48V', 'Off' )
        potLabel( f, x, 900, 'Gain' )
        drawTextCB( f, x, 1050, 'MIC B', 'f2' )

def channelLine( f, x, label=' ' ):
    if( doboxes ):
        grayBoxLabel( f, x-55, -110, 110, 1130, 0.85 )
        grayBoxLabel( f, x+55, -110, 70, 625, 0.85 )
    else:
        sw1LabelLedsR( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsR( f, x, 150, '+6dB', '0db', '+4', True )
        sw1LabelLedsR( f, x, 300, 'Bal', 'SE' )
        sw1LabelLedsR( f, x, 450, 'Cal', 'Var' )
        potLabel( f, x, 660, 'Level' ) # Was Right
        potLabel( f, x, 900, 'Level' ) # Was Left
        drawTextCB( f, x, 1050, label, 'f2' )

def meterControls( f, x ):
    potLabel( f, x, 90, 'Set Level' )
    sw1SidewaysLabel( f, x+230, 90, 'Var', '+20dB', 'Normal' )
    ledLabel( f, x+160, -20 )
    ledLabel( f, x+300, -20 )
    ledLabel( f, x+370, 90, '0dB' )
    ledLabel( f, x+470, 90, '+6dB' )
    ledLabel( f, x+570, 90, '+12dB' )
    ledLabel( f, x+670, 90, '+18dB' )
    sw1Label( f, x+790, 90, 'Record', 'Replay' )
    ledLabel( f, x+790, -20 )

def oscillator( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-55, -110, 110, 1130, 0.85 )
        grayBoxLabel( f, x-55, -110, -70, 325, 0.85 )
        grayBoxLabel( f, x-55,  800, -70, 190, 0.85 )
    else:
        sw1LabelLedsL( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsL( f, x, 150, 'Step', 'Freq' )
        ledLabel( f, x, 300, '63 Hz' )
        ledLabel( f, x, 400, '125 Hz' )
        ledLabel( f, x, 500, '1 kHz' )
        ledLabel( f, x, 600, '10 kHz' )
        ledLabel( f, x, 700, '14 kHz' )
        sw1LabelLedsL( f, x, 900, '-20dB', '0dB' )
        drawTextCB( f, x-40, 1050, 'OSCILLATOR', 'f2' )

def recordChannel( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-55, -110, 110, 1130, 0.85 )
        grayBoxLabel( f, x-55, -110, -70, 625, 0.85 )
    else:
        sw1LabelLedsL( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsL( f, x, 150, '+6dB', '0dB', '+4' )
        sw1LabelLedsL( f, x, 450, 'Cal', 'Var' )
        potLabel( f, x, 660, 'Level' )
        potLabel( f, x, 900, 'Level' )
        drawTextCB( f, x, 1050, 'RECORD', 'f2' )

def replayChannel( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-55, -110, 110, 1130, 0.85 )
        grayBoxLabel( f, x-55, -110, -70, 625, 0.85 )
    else:
        sw1LabelLedsL( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsL( f, x, 150, '+6dB', '0dB', '+4' )
        sw1LabelLedsL( f, x, 300, 'Bal', 'SE' )
        sw1LabelLedsL( f, x, 450, 'Cal', 'Var' )
        potLabel( f, x, 660, 'Level' )
        potLabel( f, x, 900, 'Level' )
        drawTextCB( f, x, 1050, 'REPLAY', 'f2' )

def monitorChannel( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-55,  380, 110, 640, 0.85 )
        grayBoxLabel( f, x-55,  380, -70, 135, 0.85 )
        grayBoxLabel( f, x-55, -110, -70, 330, 0.85 )
        grayBoxLabel( f, x-55, -110, 110, 330, 0.85 )
        grayBoxLabel( f, x-145,  233, 200, 135, 0.85 )
    else:
        sw1LabelLedsL( f, x, 0, 'On', 'Mute' )
        sw1LabelLedsL( f, x, 150, '+6dB', '0dB', '+4' )
        sw1LabelLedsL( f, x, 300, 'Input 2', 'Input 1' )
        sw1LabelLedsL( f, x, 450, 'Record', 'Replay' )
        potLabel( f, x, 900, 'Volume' )
        drawTextCB( f, x, 1050, 'MONITOR', 'f2' )

def phones( f, x ):
    if( doboxes ):
        grayBoxLabel( f, x-95, 250, 190, 770, 0.85 )
    else:
        swmainsLabel( f, x, 80, 'Power' )
        jackqtLabel( f, x, 400, 'Phones 1' )
        jackqtLabel( f, x, 660, 'Phones 2' )
        potLabel( f, x, 900, 'Volume' )
        drawTextCB( f, x, 1050, 'PHONES', 'f2' )

def panelColourBoxes( f ):
    ar = 0.7
    # Left strips
    colourBoxLabel( f, -150, 810, 1070, 190, ar, 1.0, ar, 'L', 'f2', 20 )
    colourBoxLabel( f, -150, 570, 1070, 190, 1.0, ar, ar, 'R', 'f2', 20 )
    # Right strips
    colourBoxLabel( f, 3165, 810, 430, 190, ar, 1.0, ar, 'L', 'f2', 15 )
    colourBoxLabel( f, 3165, 570, 430, 190, 1.0, ar, ar, 'R', 'f2', 15 )
    colourBoxLabel( f, 3595, 810, 380, 190, 1.0, 1.0, 0.8, ' ', 'f2', 15 )
    # Meters
    colourBoxLabel( f, 1070-100, -110, 980, 300, ar, 1.0, ar, 'L', 'f2', None, 30 )
    colourBoxLabel( f, 2050-100, -110, 980, 300, 1.0, ar, ar, 'R', 'f2', None, 30 )

#
# Draw panels ...
#

def rearPanel( f ):
    # Mic A, B inputs.
    grayBoxLabel( f, -85, -150, 360, 850, 0.85, 'Mic In', 'f2', None, 30 )
    xlrLabel( f, 95, 500, 'Mic A' )
    xlrLabel( f, 95, 120, 'Mic B' )
    # Line 1 inputs.
    grayBoxLabel( f, 335, -150, 480, 850, 0.85, 'Line 1 In', 'f2', None, 30 )
    xlrLabel( f, 495, 500, 'Line 1 L' )
    xlrLabel( f, 495, 120, 'Line 1 R' )
    phonoLabel( f, 745, 190, 'Line 1 L' )
    phonoLabel( f, 745, 0, 'Line 1 R' )
    # Line 2 inputs.
    grayBoxLabel( f, 835, -150, 480, 850, 0.85, 'Line 2 In', 'f2', None, 30 )
    xlrLabel( f, 995, 500, 'Line 2 L' )
    xlrLabel( f, 995, 120, 'Line 2 R' )
    phonoLabel( f, 1245, 190, 'Line 2 L' )
    phonoLabel( f, 1245, 0, 'Line 2 R' )
    # Line 3 inputs.
    grayBoxLabel( f, 1335, -150, 480, 850, 0.85, 'Line 3 In', 'f2', None, 30 )
    xlrLabel( f, 1495, 500, 'Line 3 L' )
    xlrLabel( f, 1495, 120, 'Line 3 R' )
    phonoLabel( f, 1745, 190, 'Line 3 L' )
    phonoLabel( f, 1745, 0, 'Line 3 R' )
    # Record channels.
    grayBoxLabel( f, 1835, -150, 780, 850, 0.85, 'Out to Recorder', 'f2', None, 30 )
    xlrLabel( f, 1995, 500, 'Bal Out 1 L' )
    xlrLabel( f, 1995, 120, 'Bal Out 1 R' )
    xlrLabel( f, 2295, 500, 'Bal Out 2 L' )
    xlrLabel( f, 2295, 120, 'Bal Out 2 R' )
    phonoLabel( f, 2545, 610, 'Out 1 L' )
    phonoLabel( f, 2545, 420, 'Out 1 R' )
    phonoLabel( f, 2545, 190, 'Out 2 L' )
    phonoLabel( f, 2545, 0, 'Out 2 R' )
    # Replay channels.
    grayBoxLabel( f, 2635, -150, 780, 850, 0.85, 'In from Reproducer', 'f2', None, 30 )
    xlrLabel( f, 2795, 500, 'Bal In 1 L' )
    xlrLabel( f, 2795, 120, 'Bal In 1 R' )
    xlrLabel( f, 3095, 500, 'Bal In 2 L' )
    xlrLabel( f, 3095, 120, 'Bal In 2 R' )
    phonoLabel( f, 3345, 610, 'In 1 L' )
    phonoLabel( f, 3345, 420, 'In 1 R' )     
    phonoLabel( f, 3345, 190, 'In 2 L' )
    phonoLabel( f, 3345, 0, 'In 2 R' )
    # Monitor
    grayBoxLabel( f, 3435, -150, 480, 850, 0.85, 'Out to Monitor', 'f2', None, 30 )
    xlrLabel( f, 3595, 500, 'Bal Out L' )
    xlrLabel( f, 3595, 120, 'Bal Out R' )   
    phonoLabel( f, 3845, 190, 'Out L' )
    phonoLabel( f, 3845, 0, 'Out R' )
    # Mains
    inletLabel( f, 3525, 860, 'Mains' )
    fuseLabel( f, 3075, 860, 'Fuse' )
    
    
    
    

# Draw front then rear panels.
for panel in range(0,2):
    if( panel == 0 ):
        dofront = True
        dorear = False
        psFileName = 'RRI_front_panel.ps'
    else:
        dofront = False
        dorear = True
        psFileName = 'RRI_rear_panel.ps'

    # Open the output file.
    f = createPSFile( psFileName )
    if f is None:
        print( 'Failed to open file {0}'.format( psFileName ) )
    else:
        print( 'Opened file {0}'.format( psFileName ) )

        # Choose what to draw.
        doControlLabels( True )
        doDrillMarks( False )

        # Step over the output pages (A4 size limit).
        for page in range(0,2):

            # Start this output page.
            beginA4landPage( f, page )

            # Draw the elements.
            if( dofront ):
                beginPanel()
                for dob in [True, False]:
                    doBoxes( dob )
                    channelMicA( f, 0 )
                    channelMicB( f, 200 )
                    channelLine( f, 400, 'LINE 1' )
                    channelLine( f, 600, 'LINE 2' )
                    channelLine( f, 800, 'LINE 3' )
                    meterControls( f, 1070 )
                    meterControls( f, 2050 )
                    oscillator( f, 3090 )
                    recordChannel( f, 3290 )
                    replayChannel( f, 3490 )
                    monitorChannel( f, 3690 )
                    phones( f, 3880 )
                    if dob:
                        panelColourBoxes( f )
                drawTextCB( f, 1948, 1050, 'RECORDER / REPRODUCER INTERFACE', 'f2' )
                dwgTitle = 'Recorder/Reproducer Interface - Front Panel'
                endPanel( dwgTitle )

            if( dorear ):
                beginPanel()
                doXMirror( True, 2135 )
                rearPanel( f )
                dwgTitle = 'Recorder/Reproducer Interface - Rear Panel'
                endPanel( dwgTitle )

            # Draw the edges for reference for cutting etc.
            drawEdges( f, -200, -200, 4270, 1290, dwgTitle )

            # End this page.
            endA4landPage( f )

        # Close the output file.
        endPSFile( f )
        print( 'Closed file {0} after {1} pages.'.format( psFileName, getPageCount() ) )
 
